/////////////////////////////////////////////////////////////////////////////
// Name:        wx/generic/pendlgg.h
// Purpose:     wxGenericPenDialog
// Author:      Martin Bernreuther
// Modified by:
// Created:     29/07/02
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////

#ifndef __PENDLGH_G__
#define __PENDLGH_G__

#ifdef __GNUG__
#pragma interface "pendlgg.h"
#endif

#include "wx/window.h"
#include "wx/dialog.h"

class wxPen;
//class wxButton;
class wxBitmapButton;
class wxChoice;
class wxSpinCtrl;
class wxColourData;

class WXDLLEXPORT wxGenPenDlgView : public wxWindow
{
private:
	const wxPen* m_pen;
public:
	wxGenPenDlgView(wxWindow *parent=(wxWindow*)NULL, const wxPen *pen=(wxPen*)NULL);
	void OnPaint(wxPaintEvent& event);
};


class WXDLLEXPORT wxGenericPenDialog : public wxDialog
{
public:
    wxGenericPenDialog(wxWindow *parent=(wxWindow*)NULL, const wxPen *pen=(wxPen*)NULL
#ifdef __WXMSW__
                      , bool showJoin=TRUE
#else
                      , bool showJoin=FALSE
#endif
                      );
    virtual ~wxGenericPenDialog() {}

    bool Create(const wxPen *pen, wxWindow *parent, bool showJoin=TRUE);

    wxPen &GetPen() { return m_pen; }

	void SetColourData(const wxColourData& colourdata) {m_colourdata=colourdata;}
	const wxColourData& GetColourData() const {return m_colourdata;}

    virtual int ShowModal();

    static wxString PenStyleNames[];
    static wxString PenCapNames[];
    static wxString PenJoinNames[];
    static wxString Labels[];

protected:
    // Internal functions
    virtual void CreateWidgets(bool showJoin=TRUE);

    virtual void OnStyleChoice();
    virtual void OnWidthSpinCtrl();
    virtual void OnColourButtonClick();
    virtual void OnCapChoice();
    virtual void OnJoinChoice();

    void OnCloseWindow(wxCloseEvent& event);

protected:
    wxPen m_pen;
    wxWindow *m_parent;


    wxChoice *m_stylechoice;
    wxSpinCtrl *m_widthspinctrl;

    //wxButton *m_colourbutton;	// m_colourbutton->SetBackgroundColour(m_pen.GetColour());
				// doesn't colour a wxButton nice with wxGTK themed buttons
				// (works for Windows)
    wxBitmapButton *m_colourbutton;

    wxChoice *m_capchoice;
    wxChoice *m_joinchoice;
    wxGenPenDlgView *m_view;

	wxColourData m_colourdata;
};


// ----------------------------------------------------------------------------
// function to get a pen from user
// ----------------------------------------------------------------------------

bool WXDLLEXPORT wxGetPenFromUser(wxPen& pen
                                 ,const wxString& title="Choose Pen"
#ifdef __WXMSW__
                                 , bool showJoin=TRUE
#else
                                 , bool showJoin=FALSE
#endif
                                 ,wxColourData *colourdata=(wxColourData*)NULL
                                 ,wxWindow *parent = (wxWindow *)NULL);

#endif